'From Squeak4.5 of 19 February 2014 [latest update: #13680] on 4 December 2014 at 3:22:54 pm'!
VariableNode subclass: #BB1RoleNode
	instanceVariableNames: 'receiver arguments selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BB1IDE-Support'!
!BB1RoleNode commentStamp: 'Trygve 11/29/2014 13:42' prior: 0!
A BB1RoleNode translates a role name to code that replaces the name with code that looks up the current roleplaying object .

E.g., role name AMOUNT becomes
	()BB1ContextStack playerForRole: #AMOUNT)
!


!BB1RoleNode methodsFor: 'accessing' stamp: 'Trygve 12/4/2014 12:03'!
asVariable: roleName contextName: ctxNam
	| arg1 |
	comment := nil.
	receiver := VariableNode new
				name: 'BB1ContextStack'
				key: #BB1ContextStack -> BB1ContextStack
				code: -4.
	selector := SelectorNode new comment: nil;
				 key: #playerForRole: code: -5.
	arg1 := LiteralVariableNode new.
	arg1 key: roleName asSymbol code: LdLitType negated.
	arg1 name: roleName.
	arguments := OrderedCollection with: arg1! !

!BB1RoleNode methodsFor: 'accessing' stamp: 'Trygve 10/26/2011 17:04'!
contextClass
	^key value! !

!BB1RoleNode methodsFor: 'accessing' stamp: 'Trygve 10/26/2011 17:30'!
receiver 
	^receiver! !

!BB1RoleNode methodsFor: 'accessing' stamp: 'Trygve 10/27/2011 14:44'!
roleName
	^arguments first key! !


!BB1RoleNode methodsFor: 'code generation' stamp: 'Trygve 11/29/2014 09:30'!
emitCodeForValue: stack encoder: encoder
	receiver ~~ nil ifTrue: [receiver emitCodeForValue: stack encoder: encoder].
	arguments do: [:argument | argument emitCodeForValue: stack encoder: encoder].
	pc := encoder methodStreamPosition + 1. "debug pc is first byte of the send, i.e. the next byte".
	selector
		emitCode: stack
		args: arguments size
		encoder: encoder
		super: receiver == NodeSuper! !

!BB1RoleNode methodsFor: 'code generation' stamp: 'Trygve 11/29/2014 09:31'!
emitCodeForValue: stack on: strm
self halt: 'error'.
	pc := 0.
	receiver ~~ nil ifTrue: [receiver emitForValue: stack on: strm].
	arguments do: [:argument | argument emitForValue: stack on: strm].
	selector
		emit: stack
		args: arguments size
		on: strm
		super: receiver == NodeSuper.
	pc _ strm position.! !

!BB1RoleNode methodsFor: 'code generation' stamp: 'Trygve 11/29/2014 09:31'!
emitForValue: stack on: strm
self halt: 'error'.
	pc := 0.
	receiver ~~ nil ifTrue: [receiver emitForValue: stack on: strm].
	arguments do: [:argument | argument emitForValue: stack on: strm].
	selector
		emit: stack
		args: arguments size
		on: strm
		super: receiver == NodeSuper.
	pc _ strm position.! !

!BB1RoleNode methodsFor: 'code generation' stamp: 'Trygve 11/29/2014 09:10'!
sizeCodeForValue: encoder
	| total |
	"special > 0 
		ifTrue: 
			[encoder noteOptimizedSelector: originalSelector.
			^self perform: (MacroSizers at: special) with: encoder with: true]."
	receiver == NodeSuper
		ifTrue: [selector := selector copy "only necess for splOops"].
	total := selector sizeCode: encoder args: arguments size super: receiver == NodeSuper.
	receiver == nil 
		ifFalse: [total := total + (receiver sizeCodeForValue: encoder)].
	arguments do: 
					[:arg | | argSize | 
					argSize := arg sizeCodeForValue: encoder.
					total := total + argSize.
					argSize].
	^total! !

!BB1RoleNode methodsFor: 'code generation' stamp: 'Trygve 11/29/2014 09:31'!
sizeForValue: encoder
	| total argSize |
self halt: 'error'.
	receiver == NodeSuper
		ifTrue: [selector := selector copy "only necess for splOops"].
	total := selector size: encoder args: arguments size super: receiver == NodeSuper.
	receiver == nil 
		ifFalse: [total := total + (receiver sizeForValue: encoder)].
self halt.
	arguments do: 
					[:arg | 
					argSize := arg sizeForValue: encoder.
					total := total + argSize.
					argSize].
	^total! !

!BB1RoleNode methodsFor: 'code generation' stamp: 'Trygve 11/29/2014 08:57'!
zzsizeCodeForValue: encoder
	| total argSize |
	true ifTrue: [^super sizeCodeForValue: encoder].
	receiver == NodeSuper
		ifTrue: [selector := selector copy "only necess for splOops"].
	total := selector size: encoder args: arguments size super: receiver == NodeSuper.
	receiver == nil 
		ifFalse: [total := total + (receiver sizeForValue: encoder)].
self halt.
	arguments do: 
					[:arg | 
					argSize := arg sizeForValue: encoder.
					total := total + argSize.
					argSize].
	^total! !


!BB1RoleNode methodsFor: 'printing' stamp: 'Trygve 8/14/2013 20:36'!
printOn: aStream indent: level
	aStream 
		nextPutAll: arguments printString , ' ' , selector printString.
		
	! !
